/* asmdef.h
 Macroses for avr-as.
 2005-03-19	Begin.
*/
#ifndef	_ASMDEF_H
#define	_ASMDEF_H  1

#if  defined(__AVR_MEGA__) && __AVR_MEGA__
#  define XJMP	jmp
#  define XCALL	call
#else
#  define XJMP	rjmp
#  define XCALL	rcall
#endif

.macro	x_movw	dst,src
#if  defined(__AVR_ENHANCED__) && __AVR_ENHANCED__
	movw	\dst,\src
#else
    .L_movw_dst = -1
    .L_movw_src = -1
    .L_movw_n = 0
    .irp  reg, r0,r2,r4,r6,r8,r10,r12,r14,r16,r18,r20,r22,r24,r26,r28,r30
	.ifc  \reg,\dst
	    .L_movw_dst = .L_movw_n
	.endif
	.ifc  \reg,\src
	    .L_movw_src = .L_movw_n
	.endif
	.L_movw_n = .L_movw_n + 2
    .endr
    .if   .L_movw_dst < 0
	.L_movw_n = 0
	.rept   16
	    .if \dst == .L_movw_n
		.L_movw_dst = .L_movw_n
	    .endif
	    .L_movw_n = .L_movw_n + 2
	.endr
    .endif
    .if   .L_movw_src < 0
	.L_movw_n = 0
	.rept   16
	    .if \src == .L_movw_n
		.L_movw_src = .L_movw_n
	    .endif
	    .L_movw_n = .L_movw_n + 2
	.endr
    .endif
    .if   (.L_movw_dst < 0) || (.L_movw_src < 0)
	.err    Invalid arg of '_movw' macro.
    .endif
	mov	\dst, \src
	mov	.L_movw_dst + 1, .L_movw_src + 1
#endif
.endm

/* ATTENTION: for classic AVR this macro changes SREG flags (S,V,N,Z,C)
   in contrast to mega chip.	*/
.macro	x_lpm_zplus	dst
#if  defined(__AVR_ENHANCED__) && __AVR_ENHANCED__
	lpm	\dst, Z+
#else
    .L_lpm_dst = -1
    .L_lpm_n = 0
    .irp  reg,   r0, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
		r10,r11,r12,r13,r14,r15,r16,r17,r18,r19, \
		r20,r21,r22,r23,r24,r25,r26,r27,r28,r29, \
		r30,r31
	.ifc  \reg,\dst
	    .L_lpm_dst = .L_lpm_n
	.endif
	.L_lpm_n = .L_lpm_n + 1
    .endr
    .if  .L_lpm_dst < 0
	.L_lpm_n = 0
	.rept 32
	    .if  \dst == .L_lpm_n
		.L_lpm_dst = .L_lpm_n
	    .endif
	    .L_lpm_n = .L_lpm_n + 1
	.endr
    .endif
    .if  (.L_lpm_dst < 0)
	.err	Invalid arg of 'x_lpm_zplus' macro.
    .endif
    .if  (.L_lpm_dst >= 30)
	.err	Registers 30 and 31 are inhibited as 'x_lpm_zplus' dst.
    .endif

	lpm
    .if  .L_lpm_dst
	mov	.L_lpm_dst, r0
    .endif
	adiw	r30, 1
#endif
.endm

/* Number of Tail Zeros:  ntz(x)= (ffs(x) ? ffs(x)-1 : 16)
   It works with all: cpp, gcc and gas expressions.	*/
#define ntz(x)	\
	( (1 & (((x) & 1) == 0))        \
	+ (1 & (((x) & 3) == 0))        \
    	+ (1 & (((x) & 7) == 0))        \
        + (1 & (((x) & 017) == 0))      \
        + (1 & (((x) & 037) == 0))      \
	+ (1 & (((x) & 077) == 0))      \
	+ (1 & (((x) & 0177) == 0))     \
	+ (1 & (((x) & 0377) == 0))     \
	+ (1 & (((x) & 0777) == 0))     \
	+ (1 & (((x) & 01777) == 0))    \
	+ (1 & (((x) & 03777) == 0))    \
	+ (1 & (((x) & 07777) == 0))    \
	+ (1 & (((x) & 017777) == 0))   \
	+ (1 & (((x) & 037777) == 0))   \
	+ (1 & (((x) & 077777) == 0))   \
	+ (1 & (((x) & 0177777) == 0)) )

#define	XL	r26
#define	XH	r27
#define	YL	r28
#define	YH	r29
#define	ZL	r30
#define	ZH	r31

#endif	/* _ASMDEF_H */
