/* dtostre.c
 2005-03-20	Begin.
 2005-03-22	Last modif.
*/
#include <stdlib.h>
#include "ftoa_engine.h"

#ifndef	AVR_IEEE754		/* FIXME */
#  define AVR_IEEE754	1
#endif

char *
dtostre (double val, char *sout, unsigned char prec, unsigned char flags)
{
    char *d;		/* dst	*/
    char *s;		/* src	*/
    signed char exp;
    unsigned char ftoa;

    if (prec > 7) prec = 7;
    
    exp = __ftoa_engine (val, sout, prec, 0);
    d = s = sout;
    ftoa = *s++;

    if (AVR_IEEE754) {
	if (ftoa & FTOA_NAN) {
	    if (flags & DTOSTR_PLUS_SIGN)
		*d++ = '+';
	    else if (flags & DTOSTR_ALWAYS_SIGN)
		*d++ = ' ';
	    if (flags & DTOSTR_UPPERCASE) {
		*d++ = 'N';  *d++ = 'A';  *d++ = 'N';
	    } else {
		*d++ = 'n';  *d++ = 'a';  *d++ = 'n';
	    }
	    goto ret;
	}
    }
    
    if (ftoa & FTOA_MINUS)
	*d++ = '-';
    else if (flags & DTOSTR_PLUS_SIGN)
	*d++ = '+';
    else if (flags & DTOSTR_ALWAYS_SIGN)
	*d++ = ' ';
    
    if (AVR_IEEE754) {
	if (ftoa & FTOA_INF) {
	    if (flags & DTOSTR_UPPERCASE) {
		*d++ = 'I';  *d++ = 'N';  *d++ = 'F';
	    } else {
		*d++ = 'i';  *d++ = 'n';  *d++ = 'f';
	    }
	    goto ret;
	}
    }
    
    /* mantissa	*/
    *d++ = *s++;
    if (prec) {
	unsigned char c1, c2;
	c1 = '.';
	do {
	    c2 = *s++;
	    *d++ = c1;
	    c1 = c2;
	} while (--prec);
	*d++ = c1;
    }

    /* exponent	*/
    *d++ = (flags & DTOSTR_UPPERCASE) ? 'E' : 'e';
    if (exp < 0) {
	*d++ = '-';
	exp = -exp;
    } else if (exp == 0 && (ftoa & FTOA_LESSONE)) {
	*d++ = '-';
    } else {
	*d++ = '+';
    }
    for (prec = '0';  exp >= 10;  exp -= 10)
	prec += 1;
    *d++ = prec;
    *d++ = '0' + exp;
    
  ret:
    *d = 0;
    return sout;
}
			/*** end of file ***/
