#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "run.h"

#define	PZLEN	5	/* protected zone length	*/

void run_dtostre (const struct dtostre_s *pt, int testno)
{
    union {
	long lo;
	float fl;
    } val;
    unsigned char prec, flags;
    static unsigned char s[2*PZLEN + sizeof(pt->pattern)];
    unsigned char c, *ps;
    void *pv;
    
    memset(s, testno, sizeof(s));

#ifdef	__AVR__
    val.lo = pgm_read_dword (& pt->lo);
    prec   = pgm_read_byte (& pt->prec);
    flags  = pgm_read_byte (& pt->flags);
#else
    val.lo = pt->lo;
    prec   = pt->prec;
    flags  = pt->flags;
#endif
    ps = dtostre (val.fl, s + PZLEN, prec, flags);

    if (ps != s + PZLEN)
	exit (testno + 0x1000);
    for (ps = s; ps != s + PZLEN; ps++) {
	if (*ps != (testno & 0377))
	    exit (testno + 0x2000);
    }

    pv = & pt->pattern;
#ifdef	__AVR__
    do {
	c = pgm_read_byte(pv++);
	if (*ps++ != c) {
	    exit (testno + 0x3000);
	}
    } while (c);
#else
    do {
	c = *(char *)(pv++);
	if (*ps++ != c) {
	    fprintf (stderr, "*** testno= %d:  must= %s  was= %s\n",
		testno, pt->pattern, s + PZLEN);
	    exit (testno + 0x3000);
	}
    } while (c);
#endif

    for (; ps != s + sizeof(s); ps++) {
	if (*ps != (testno & 0377))
	    exit (testno + 0x4000);
    }
}
